/* eslint-disable camelcase space-in-parens */
<i18n>
{
  "fr": {
    "title-1": "Le matériel informatique",
    "title-2": "Suppression",
    "error-msg": "Des données ne sont pas valides, continuer va entraîner leur suppression. <br /> Êtes vous sûr de vouloir continuer?",
    "save-msg": "Les informations du matériel informatique ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>.",
    "info-1": "Veuillez téléverser la liste de vos équipements numériques financés sur crédits du laboratoire en",
    "info-2": ", toutes tutelles confondues, au format .tsv",
    "info-3": "exemple",
    "info-4": "Ce fichier doit contenir un item par ligne, avec les trois colonnes suivantes :",
    "info-5": "<b>Type</b>, identifiant la catégorie de l'item parmi (avec entre parenthèses quelques alias autorisés) : PC fixe (Desktop, PC, fixe, tour, unité centrale, station de travail, workstation), PC portable (laptop, portable, notebook), Serveur, Écran (monitor, display, screen), Vidéo projecteur, Tablette (pad), Smartphone (mobile), Imprimante, Borne wifi (Wifi hub), Téléphone IP, GPU, Disque dur, Clavier, Souris.",
    "info-6": "<b>Fabricant</b>, c'est à dire la marque de l'item, exemples : DELL, HP, Lenovo, ACER, Apple, etc.",
    "info-7": "<b>Modèle</b>, permettant d'identifier plus précisément l'item, exemples : Latitude 5280, PowerEdge T640, Precision Tower 3630, etc.",
    "info-8": "Notez que les colonnes <b>Fabricant</b> et <b>Modèle</b> peuvent être incomplètes voire vides. Le cas échéant, le bilan s'appuiera sur des valeurs par défaut, avec un degré d'incertitude plus important.",
    "info-9": "Note",
    "info-10": "Ce module embarque une copie de l'outil",
    "info-11": "du GDS",
    "info-12": "du CNRS"
  },
  "en": {
    "title-1": "Digital devices",
    "save-msg": "The data relating to the digital devices have been <strong><span style='color:green;'>successfully</span></strong>saved.",
    "title-2": "Delete",
    "error-msg": "Some data are not valid. If you continue to proceed, they will be deleted. <br /> Are you sure you want to proceed?",
    "info-1": "Please upload the list of all the digital devices that were paid by your laboratory in",
    "info-2": ", all supervisory included, in .tsv format",
    "info-3": "example",
    "info-4": "This file must contain a device per row, with the following three columns :",
    "info-5": "<b>Type</b>, corresponding to the category of the device among (with a few aliases allowed, between brackets) : Desktop (PC, main frame, workstation), Laptop (notebook), Server, Monitor (display, screen), Video projector, Pad, Smartphone, Printer, Wifi hub, IP telephone, GPU, Hard drive, Keyboard, Mouse.",
    "info-6": "<b>Brand name </b>, i.e. the brand name of the device, such as : DELL, HP, Lenovo, ACER, Apple, etc.",
    "info-7": "<b>Model</b>, identifies the device more precisely ; examples : Latitude 5280, PowerEdge T640, Precision Tower 3630, etc.",
    "info-8": "<b>Brand name</b> and <b>Model</b> columns may be incomplete or even empty. When needed, the tool will use default values, with a higher degree of uncertainty.",
    "info-9": "Note",
    "info-10": "This module contains a replica of the tool",
    "info-11": "developed by the GDS",
    "info-12": "of the CNRS"
  }
}
</i18n>

<template>
  <div>
    <serveur-info :erreur="module.erreur"/>
    <su-service :icon="'desktop'">
      <template #title>
        {{ $t('title-1') }}
      </template>
      <div class="content">
        <p>
          {{ $t('info-1') }} <b>{{currentYear}}</b>{{ $t('info-2') }}
          (<a href="/static/carbon/devicesTemplate.tsv" download>{{ $t('info-3') }}</a>).
          {{ $t('info-4') }}
        </p>
        <ul>
          <li v-html="$t('info-5')"></li>
          <li v-html="$t('info-6')"></li>
          <li v-html="$t('info-7')"></li>
        </ul>
        <p v-html="$t('info-8')"></p>
        <p>
          {{ $t('info-9') }} : <em>{{ $t('info-10') }}
          <a target="_blank" class="link" href="https://ecoinfo.cnrs.fr/ecodiag-calcul">
            Ecodiag
          </a> {{ $t('info-11') }}
          <a target="_blank" class="link" href="https://ecoinfo.cnrs.fr">
            EcoInfo
          </a> {{ $t('info-12') }}.</em>
        </p>
      </div>
    </su-service>
    <br />

    <ecodiag-hybrid-device-table
      GES1p5
      ref="ecodiagComponent"
      :devicelist="ecodiagDevices"
      :nb-users="nMember"
      :reference-year="currentYear"
      :optional-columns="[]"
      method="flux"
      :autoAdd="false"
      :narrowed="false"
      @updated="itemsUpdated"
      @deleted="itemsDeleted"
      :per-page="50"
      hideTools
      autoSimplify
      :read-only="submitted">
    </ecodiag-hybrid-device-table>

    <computer-device-modal
      v-if="modalItem!==null"
      :displayModal="displayModal"
      :item="modalItem"
      :modeCreation="modeCreation"
      @close="closeModal"
      @validated="modalValidated"
    />

    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="level-right">
        <div class="buttons">
          <b-button
            class="button"
            :disabled="submitted"
            icon-left="plus"
            @click="addItem()"
          >
            {{ $t('add') }}
          </b-button>
          <b-button
            class="level-item"
            :icon-left="validSavedIcon"
            :disabled="!module.isModified"
            type="is-primary"
            @click="validate"
          >
            <span v-if="isAuthenticated">{{ $t('save') }}</span>
            <span v-else>{{ $t('validate') }}</span>
          </b-button>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
/* eslint-disable camelcase */

import { device_utils } from '@/ext/ecodiag/device_utils'
import { mapGetters } from 'vuex'

export default {
  name: 'ComputerDevices',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'serveur-info': () => import('@/components/ServeurInfo.vue'),
    'ecodiag-hybrid-device-table': () => import('@/ext/ecodiag/components/hybrid_device_table.vue'),
    'computer-device-modal': () => import('@/components/carbon/forms/ComputerDeviceModal.vue')
  },

  mixins: [device_utils],
  data () {
    return {
      modalItem: null,
      modeCreation: true,
      displayModal: false }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    validSavedIcon () {
      let icon = null
      if (this.isAuthenticated) {
        icon = 'save'
      } else {
        icon = 'check'
      }
      return icon
    },
    computerDevices: function () {
      return this.$store.getters['computerdevices/items']
    },
    ecodiagDevices: function () {
      return this.computerDevices.map(obj => obj.toEcodiag())
    },
    module: function () {
      return this.$store.getters['computerdevices/module']
    },
    currentYear () {
      return this.$store.getters['ghgi/item']['year']
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['devicesSubmitted']
    },
    nMember () {
      return this.$store.getters['ghgi/nMember']
    }
  },
  mounted () {
    // configure ecodiag with appropriate damping factor, i.e., 1 year
    this.params.damping_factor = 1
    this.params.ignore_year = true
    this.params.get_default_model = function (type) {
      return 'default'
    }
  },
  methods: {
    validate: function () {
      let self = this
      let invalidItems = this.ecodiagDevices.filter(e => !this.is_valid(e, 'flux', this.currentYear))
      if (invalidItems.length > 0) {
        this.$buefy.dialog.confirm({
          title: self.$t('title-2'),
          message: self.$t('error-msg'),
          confirmText: this.$t('validate'),
          canCancel: ['escape', 'button', 'outside'],
          onConfirm: function () {
            self.$refs.ecodiagComponent.delete_invalids()
            self.$refs.ecodiagComponent.simplify_data(true, this.isAuthenticated)
            self.subValidate()
          }
        })
      } else {
        self.$refs.ecodiagComponent.simplify_data(true, this.isAuthenticated)
        this.subValidate()
      }
    },
    subValidate: function () {
      if (this.isAuthenticated) {
        const loadingComponent = this.$buefy.loading.open({
          container: null
        })
        this.$store.dispatch('computerdevices/save')
          .then(data => {
            loadingComponent.close()
            if (this.computerDevices.length === 0) {
              this.$store.commit('computerdevices/ISVALID', false)
            } else {
              this.$store.commit('computerdevices/ISVALID', true)
            }
            this.$store.commit('computerdevices/ERREUR', '')
            this.$store.commit('computerdevices/ISMODIFIED', false)
            window.scrollTo(0, 0)
            this.$buefy.toast.open({
              type: 'is-light',
              message: this.$t('save-msg')
            })
          })
          .catch((erreur) => {
            loadingComponent.close()
            this.$store.commit('computerdevices/ISVALID', false)
            this.$store.commit('computerdevices/ERREUR', erreur.response.data)
          })
      } else {
        if (this.computerDevices.length === 0) {
          this.$store.commit('computerdevices/ISVALID', false)
        } else {
          this.$store.commit('computerdevices/ISVALID', true)
        }
        this.$store.commit('computerdevices/ISMODIFIED', false)
      }
    },
    addItem () {
      this.modalItem = this.create_device_item(null, { nb: 1, year: this.currentYear, score: 2 })
      this.modeCreation = true
      this.displayModal = true
    },
    itemsUpdated (items) {
      this.$store.dispatch('computerdevices/update', items)
      if (this.$store.getters['computerdevices/isActive']) {
        this.$store.commit('computerdevices/ISMODIFIED', true)
      }
    },
    itemsDeleted (items) {
      this.$store.dispatch('computerdevices/delete', items)
      this.$store.commit('computerdevices/ISMODIFIED', true)
    },
    modalValidated (item) {
      if (this.modeCreation) {
        this.$refs.ecodiagComponent.item_added()
        this.$store.dispatch('computerdevices/add', item)
      } else {
        this.$store.dispatch('computerdevices/update', item)
      }
      this.$store.commit('computerdevices/ISMODIFIED', true)
      this.modalItem = null
      this.displayModal = false
    },
    closeModal () {
      this.displayModal = false
      this.modalItem = null
    }
  }
}
</script>
